import StringIO
from satine.stream import reader, writer
import satine
from types import *
import sys

doc = """
        <addressbook xmlns:d="http://d">
          <person d:prova="ni" surname="Gates" name="Bill">The Microsoft chief</person>
          <person surname="Tolvald" name="Linus">The Linux creator</person>
          <person surname="Goethe" name="Wolfgang">German romantic poet</person>
          <person surname="Eco" name="Umberto">Italian writer</person>
          <person surname="Monet" name="Claude">French painter</person>
        </addressbook>
        """

def scanner():
    st = reader(StringIO.StringIO(doc))

    for element in st:
        if satine.is_xlist(element):
            if element.tpinfo.tag == "addressbook":
                print "starting..."
            elif element.tpinfo.tag == "person":
                print "person",element.name,element.surname
        elif element == None:               #a None object which maps an element closure
            print "---------------------"
        else:
            print "info:", element

    ls = []

    w = writer(sys.stdout)
    for element in st:
        w.write([element])        
scanner()
