import satine
from time import *
import sys

def satineVisit(obj):
    for i in obj.__dict__:
        ghost = obj[i]    
    for i in obj:
        if satine.is_xlist(i):
            satineVisit(i)

def satineTest(filename):
    rd = open(filename)
    data = rd.read()
    
    before = time()
    obj = satine.xml2py(data)
    after = time()
    create = after-before

    before = time()
    satineVisit(obj)
    after = time()
    visit = after-before
    return create,visit

def objVisit(obj):
    if type(obj) is InstanceType:
        for i in dir(obj):
            k = getattr(obj,i)
            objVisit(k)
    elif type(obj) is ListType:
        for k in obj:
            objVisit(k)
        
def objTest(filename):
    before = time()
    obj = XML_Objectify(filename).make_instance()
    after = time()
    create = after-before

    before = time()
    objVisit(obj)
    after = time()
    visit = after-before
    return create,visit

for filename in sys.argv[1:]:
    print "Testing ",filename

    sat_create, sat_visit = satineTest(filename)
#    obj_create, obj_visit = objTest(filename)
    
    print "creation comparison in ms: satine =",sat_create #,"objectfy =", obj_create,"ratio =",obj_create/sat_create

    print "visit comparison in ms: satine =",sat_visit #,"objectfy =", obj_visit,"ratio =",obj_visit/sat_visit
        
sleep(2)
